module eu(C, ZF, A, B, ALUc, CFl, ZFl, CLK, res);
  output [7:0] C;
  output ZF;
  input [7:0] A, B;
  input [4:0] ALUc;
  input	CFl, ZFl, CLK, res;

  reg	CF, ZF;

  wire	CFo, ZFo;

  assign #1 ZFo = ~| C;

  assign #4 {CFo,C} =
    (ALUc == 5'b00000) ? A :
    (ALUc == 5'b00001) ? B :
    (ALUc == 5'b00010) ? (CF?A+B:A) :
    (ALUc == 5'b00011) ? (ZF?A+B:A) :
    (ALUc == 5'b00100) ? A&B :
    (ALUc == 5'b00101) ? A|B :
    (ALUc == 5'b00110) ? A^B :
    (ALUc == 5'b00111) ? A&B :
    (ALUc == 5'b01000) ? {1'b0,A}+{1'b0,B} :
    (ALUc == 5'b01001) ? {1'b0,A}+{1'b0,B}+{8'b0,CF} :
    (ALUc == 5'b01010) ? {1'b0,A}-{1'b0,B} :
    (ALUc == 5'b01011) ? {1'b0,A}-{1'b0,B}-{8'b0,CF} :
//  (ALUc == 5'b01100) ?
//  (ALUc == 5'b01101) ?
//  (ALUc == 5'b01110) ?
    (ALUc == 5'b01111) ? {1'b0,A}-{1'b0,B} :
    (ALUc == 5'b10000) ? {1'b0,A}+9'b1 :
    (ALUc == 5'b10001) ? {1'b0,A}-9'b1 :
    (ALUc == 5'b10010) ? -A :
    (ALUc == 5'b10011) ? ~A :
    (ALUc == 5'b10100) ? {A[7],A[6:0],1'b0} :
    (ALUc == 5'b10101) ? {A[0],1'b0,A[7:1]} :
    (ALUc == 5'b10110) ? {A[0],A[7],A[7:1]} :
    (ALUc == 5'b10111) ? {A[7],A[6:0],A[7]} :
    (ALUc == 5'b11000) ? {A[0],A[0],A[7:1]} :
    (ALUc == 5'b11001) ? {A[7:0],CF} :
    (ALUc == 5'b11010) ? {A[0],CF,A[7:1]} :
//  (ALUc == 5'b11011) ?
//  (ALUc == 5'b11100) ?
//  (ALUc == 5'b11101) ?
    (ALUc == 5'b11110) ? 9'b000000000 :
    (ALUc == 5'b11111) ? 9'b111111111 :
		      8'bz;

  always @(posedge CLK)
    begin
//      if(!res) CF = 1'b0;
//      if(!res) ZF = 1'b0;
      if(CFl)  CF = CFo;
      if(ZFl)  ZF = ZFo;
    end
endmodule
/*

---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
   | _0| _1| _2| _3| _4| _5| _6| _7| _8| _9| _A| _B| _C| _D| _E| _F|
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 0_|NOP|   |   |   | ? |LSP|SSP| ! | ! |RET|POP| ! |PUS|   |OUT|HLT|
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 1_|   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 2_|   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 3_|   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 4_| ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ? | ? |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 5_| ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! |CLC|STC|
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 6_| ! | ! |NEG|NOT| ! | ! | ! | ! | ! | ! | ! | ! | ! | ! |STZ|CLZ|
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 7_|INC|DEC| ! | ! |LSL|LSR|ASR|ROL|ROR|RLC|RRC| ! | ! | ! | ! | ! |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 8_| ! |LD | ! | ! |AND|OR |XOR|TST|ADD|ADC|SUB|SBB| ! | ! | ! |CMP|	imm
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 9_| ! |LD | ! | ! |AND|OR |XOR|TST|ADD|ADC|SUB|SBB| ! | ! | ! |CMP|	dir
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 A_| ! |LD | ! | ! |AND|OR |XOR|TST|ADD|ADC|SUB|SBB| ! | ! | ! |CMP|	ind
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 B_| ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! | ! |	in-ind
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 C_| ! | ! |JC |JZ | ! | ! | ! | ! |JMP|JMP|JMP| ! |CAL|CAL|CAL| ! |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 D_| ! |ST |ST | ! |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 E_|   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
 F_|   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |   |
---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
*/
